SeedRnd MilliSecs()
Const Black = $FF000000
Const White = $FFFFFFFF
Const screenwidth = 1024
Const ScreenHeight = 768
Const LogicalDisplayWidth = 800
Const LogicalDisplayHeight = 600

Include "LvDNet.bb"
Include "LvdInputs.bb"
Include "LvdGameMode.bb"


If NetworkedGame Then InitNetworkGame() 

Graphics3D ScreenWidth,ScreenHeight
SetBuffer BackBuffer()

Global GameView = CreatePivot()

Global GameCamera=CreateCamera(GameView)

Global Gamelight=CreateLight(GameCamera)
RotateEntity Gamelight,90,0,0

Global Zoom#= 0.6

Function InverseShade(Shade)
	If Shade=Black Then Return White Else Return Black
End Function

Font = LoadFont("Arial",12,False)
SetFont Font

Global ResultsFont = LoadFont("Arial",24,True)

Const PerlinB = $100
Const PerlinBM = $FF

Dim PerlinP#(PerlinB+PerlinB+2)
Dim PerlinG2#(PerlinB + PerlinB + 2,2)

Function s_curve#(t#) 
	Return  t * t * (3.0- 2.0* t) 
End Function

Function lerp#(t#, a#, b#)
	Return ( a + t * (b - a) )
End Function

Function initPerlin()
	For i = 0 To PerlinB-1
		PerlinP(I) = I;

		For j = 0 To 1
			PerlinG2(I,J) = Rand(-256,256)/256.0
		Next 
		L2# = PerlinG2(I,0)*PerlinG2(I,0) + PerlinG2(I,1)+PerlinG2(I,1)
		If L2 = 0 Then 
			PerlinG2(I,0)=1
			PerlinG2(I,1)=0
		Else
			L# = Sqr(L2)			
			PerlinG2(I,0)=PerlinG2(I,0)/L
			PerlinG2(I,1)=PerlinG2(I,1)/L			
		End If
	Next
	
	For i = 0 To PerlinB-1
		k# = PerlinP(i)
		J = Rand(PerlinB)
		PerlinP(i) = PerlinP(J)
		PerlinP(j) = k
	Next

	For i = 0 To PerlinB + 1 
		PerlinP(PerlinB + i) = PerlinP(i);
		For j = 0 To 1
			PerlinG2(PerlinB + i,J) = PerlinG2(I,J);
		Next
	Next
End Function


Function noise2(IX#,IY#)

	t#= IX + $1000
	BX0 = Int(T) And PerlinBM 
	BX1 = (BX0+1) And PerlinBM 
	RX0# = T- Int(T)
	RX1# = Rx0 - 1

	t#= IY + $1000
	BY0 = Int(T) And PerlinBM 
	BY1 = (BY0+1) And PerlinBM 
	RY0# = T- Int(T)
	RY1# = RY0 - 1
	
	I# = PerlinP(BX0)
	J# = PerlinP(BX1)

	b00 = PerlinP( i + by0 );
	b10 = PerlinP( j + by0 );
	b01 = PerlinP( i + by1 );
	b11 = PerlinP( j + by1 );

	sx# = s_curve(rx0);
	sy# = s_curve(ry0);
	
	Gx#=PerlinG2(b00,0)
	Gy#=PerlinG2(b00,1)	
	U# = Gx * Rx0 + Gy * ry0
	;q = g2[ b00 ] ; u = at2(rx0,ry0);

	Gx#=PerlinG2(b10,0)
	Gy#=PerlinG2(b10,1)	
	V# = Gx * Rx1 + Gy * ry0
	;q = g2[ b10 ] ; v = at2(rx1,ry0);
	
	a# =  U + SX * (V - U) ;lerp(sx, u, v);

	U# = PerlinG2(b01,0) * Rx0 + PerlinG2(b01,1) * ry1
	;q = g2[ b01 ] ; u = at2(rx0,ry1);

	V# = PerlinG2(b11,0) * Rx1 + PerlinG2(b11,1) * ry1
	;q = g2[ b11 ] ; v = at2(rx1,ry1);
	b# = U + SX * (V - U) ;lerp(sx, u, v);

	Return A + SY * (B - A);lerp(sy, a, b);
End Function 

Function shadowText(X,Y,T$,Cx=False,cy=False)
	Color 0,0,0


	Text X+1,Y+1,T,Cx,Cy
	Color 255,255,50
	Text X,Y,T,Cx,Cy
End Function

Function CreateQuad(ParentEntity = 0)
  mesh=CreateMesh()
  surf=CreateSurface(mesh)
  v0=AddVertex(surf,-1.0, -1.0,  0, 0,0 )
  v1=AddVertex(surf,-1.0,  1.0,  0, 0,1 )
  v2=AddVertex(surf,1.0,  1.0,  0, 1,1 )
  v3=AddVertex(surf,1.0, -1.0,  0, 1,0 )
  AddTriangle(surf,v0,v1,v2)
  AddTriangle(surf,v2,v3,v0)
  UpdateNormals mesh
  If ParentEntity <> 0 Then EntityParent Mesh,ParentEntity
  Return mesh
End Function

Const worldSize = 1024

Global Pattern1 = ImageBuffer(LoadImage("Data/Pattern1.png"))
Global Pattern2 = ImageBuffer(LoadImage("Data/Pattern2.png"))

Global Instructions = LoadImage("Data/Instructions.png")
Global GoButton = LoadImage("Data/GoButton.png")
Global MousePointer = LoadImage("Data/MousePointer.png")
Dim RoundWindow(3)

RoundWindow(1) = LoadImage("Data/Round1.png")
RoundWindow(2) = LoadImage("Data/Round2.png")
RoundWindow(3) = LoadImage("Data/Round3.png")

Global DarkWinsGame = LoadImage("Data/DarkWinsGame.png")
Global LightWinsGame = LoadImage("Data/LightWinsGame.png")
Global DarkWinsRound = LoadImage("Data/DarkWinsRound.png")
Global LightWinsRound = LoadImage("Data/LightWinsRound.png")

Global RoundDrawn = LoadImage("Data/RoundDrawn.png")
Global GameDrawn = LoadImage("Data/GameDrawn.png")


Global InfoPanel = LoadImage("Data/InfoPanel.png")



Global GeneratingLevel = LoadImage("Data/GeneratingLevel.png")

Quad=CreateQuad(GameView)
PositionEntity Quad,512,512,180
ScaleEntity Quad,512,512,1
EntityFX quad,1+4

Global WorldImage = CreateImage(WorldSize,WorldSize)
Global WorldTexture=CreateTexture(WorldSize,WorldSize,1)
Global WorldBuffer = ImageBuffer(WorldImage)

Global ExplosionTexture = LoadAnimTexture ("Data/Explosion.jpg",1,64,64,0,16)
Global IExplosionTexture = LoadAnimTexture ("Data/IExplosion.jpg",1,64,64,0,16)

Global GribblyTexture = LoadTexture ("Data/Gribbly.jpg",1)
Global IGribblyTexture = LoadTexture ("Data/IGribbly.jpg",1)

Global GlossTexture = LoadTexture ("Data/GlossEnv.jpg",65)
TextureBlend GlossTexture,3


Function UpdateWorldTexture()
	CopyRect 0,0,WorldSize,WorldSize,0,0,WorldBuffer,TextureBuffer(WorldTexture)
End Function


Function MakeWorldPattern()
	dx1=Rand(1024)
	dx2=Rand(1024)
	dy1=Rand(1024)
	dy2=Rand(1024)
	
	LockBuffer WorldBuffer
	LockBuffer	 Pattern1
	LockBuffer Pattern2
	For ty = 0 To WorldSize-1
		For tx=0 To WorldSize-1
			A= ReadPixelFast((tx+dx1) And (1023),(ty+dy1)And (1023),Pattern1)And $ff
			B= ReadPixelFast((tx+dx2) And (1023),(ty+dy2)And (1023),Pattern2)And $ff
			C= (A - 127) + (B - 127) 
			If C < 0 Then
				 cl = $FFFFFFFF
			ElseIf C > 0 Then 
				cl = $FF000000
			Else 
				Cl=$FF808080
			End If
			;If Rnd(0,1) > 0.5 Then B= $FFFFFFFF Else B = $FF000000 
			WritePixelFast tx,ty,CL
		Next	
	Next
	UnlockBuffer WorldBuffer
	UnlockBuffer Pattern1
	UnlockBuffer Pattern2
End Function

Type tPlayer
	Field DeathCount
	Field Shade
	Field Entity
	Field Dx#,Dy#
	Field InitialX#,InitialY#
	Field X#,Y#
	Field Angle#
	Field windowLeft,WindowTop,WindowRight,WindowBottom
	Field Camera
	Field Dead
	Field RespawnCountdown
End Type

Type tBullet
	Field Shade
	Field Entity
	Field Dx#,Dy#
	Field X#,Y#
	Field Dead
	Field Age
End Type

Type tExplosion
	Field sprite
	Field Texture
	Field X#,Y#
	Field Age
	Field Size
End Type
Const GribblySize = 5
Const GribblyTailLength = 8
Type tGribbly
	Field Shade
	Field X#,Y#
	Field Dx#,DY#
	Field HomeX#
	Field HomeY#
	Field Sprite[GribblyTailLength]
	Field Texture
	Field isHome 
	Field Dead
End Type

Global BlackGribbliesHome
Global WhiteGribbliesHome
Global BlackGribbliesInWild
Global WhiteGribbliesInWild


Function CreateGribbly.tGribbly(X#,Y#,Shade,HomeX#,HomeY#)
	Result.tGribbly = New tGribbly
	Result\Shade = Shade
	Result\X = X
	Result\Y = Y
	Result\HomeX = HomeX
	Result\HomeY = HomeY
	
	Sprite = CreateSprite(Gameview)
	PositionEntity Sprite,X,Y,90
	ScaleSprite Sprite,GribblySize,GribblySize
	If shade = White Then
		EntityBlend Sprite,3
		result\Texture=GribblyTexture
	Else
		result\Texture=IGribblyTexture
		EntityBlend Sprite,2
	End If
	EntityTexture Sprite,Result\Texture,0
	For I = 1 To GribblyTailLength
		sc#=1.0/GribblyTailLength
		Result\Sprite[I] = CopyEntity (Sprite,GameView)
		EntityAlpha Result\Sprite[I], (1.0- (I*sc))
		ScaleSprite Result\Sprite[I],GribblySize*(1.0- (I*sc)),GribblySize*(1.0- (I*sc))
	Next
	Result\Sprite[0]= Sprite
	Return Result
End Function

Function MoveGribblies(MoveTails= True)
	BlackGribbliesHome= 0
	WhiteGribbliesHome= 0
	BlackGribbliesInWild = 0
	WhiteGribbliesInWild = 0
	
	For Gribbly.tGribbly = Each tGribbly 
		If MoveTails Then
			For I = GribblyTailLength To 1 Step -1
				PositionEntity  Gribbly\Sprite[I],EntityX(Gribbly\Sprite[I-1]),EntityY(Gribbly\Sprite[I-1]),EntityZ(Gribbly\Sprite[I-1])
			Next
		EndIf
		DX#=Gribbly\DX
		DY#=Gribbly\DY

		NewX#=Gribbly\X+Dx
		NewY#=Gribbly\Y+Dy
		Dx=Dx * 0.999 + Rnd(-0.1,0.1)
		Dy = dy * 0.999 + Rnd(-0.1,0.1)
		If dx < -1 Then Dx= -1
		If dx > 1 Then dx = 1
		If dy < -1 Then Dy= -1
		If dy > 1 Then dy = 1
		
		If ReadMap(NewX,NewY) <> inverseShade(Gribbly\Shade) Then
			Dx=dy
			dy=Dx
			If Rnd(0,1) >0.5 Then Dx=-dx
			If Rnd(0,1) >0.5 Then Dy=-dy
			
			;If Abs(Dx) > Abs(Dy) Then Dx = -Dx Else Dy=-Dy
		Else
			;Stop
			Gribbly\X = NewX
			Gribbly\Y = NewY
		End If
		PositionEntity Gribbly\Sprite[0],Gribbly\X,Gribbly\Y,100
		hx#= Gribbly\X-Gribbly\HomeX
		hy#= Gribbly\Y-Gribbly\HomeY
		Hd2# = hx*hx+Hy*hY
		If Hd2 = 0 Then 
			hd#=0 
			hx=0
			hy=0
		Else 
			Hd#=Sqr(Hd2)
			hx=(hx/hd)*0.03
			hy=(hy/hd)*0.03
		End If
		Gribbly\Dx=Dx-hx
		Gribbly\Dy=Dy-Hy
		Gribbly\ishome = hd<64
		If Gribbly\IsHome Then
			If Gribbly\Shade=Black Then BlackGribbliesHome=BlackGribbliesHome+1
			If Gribbly\Shade=White Then WhiteGribbliesHome=WhiteGribbliesHome+1
		Else
			If Gribbly\Shade=Black Then BlackGribbliesInWild=BlackGribbliesInWild+1
			If Gribbly\Shade=White Then WhiteGribbliesInWild=WhiteGribbliesInWild+1		
		End If
		If ReadMap(Gribbly\X,Gribbly\Y)  <> InverseShade(Gribbly\Shade) Then
			Gribbly\dead = True
		End If
		;If Hd < 64 Then EntityColor Gribbly\Sprite,0,255,0 Else EntityColor gribbly\sprite,255,255,255
	Next
End Function

Function DestroyGribbly(Gribbly.tGribbly)
	For I= 0 To GribblyTailLength
		FreeEntity	Gribbly\Sprite[I]
	Next
	Delete Gribbly
End Function

Function FreeDeadGribblies()
	For Gribbly.tGribbly = Each tGribbly 
		If Gribbly\Dead Then DestroyGribbly(Gribbly)
	Next
End Function

Function FreeAllGribblies()
	For Gribbly.tGribbly = Each tGribbly 
		DestroyGribbly(Gribbly)
	Next
End Function

Function CreateExplosion.tExplosion(X,Y,shade,Size=1)
	Result.tExplosion = New tExplosion
	Result\X = X
	Result\Y = Y
	Result\Sprite = CreateSprite(GameView)
	PositionEntity Result\Sprite,X,Y,90
	If shade = black Then
		EntityBlend Result\Sprite,3
		result\Texture=ExplosionTexture
	Else
		result\Texture=IExplosionTexture
		EntityBlend Result\Sprite,2
	End If
	EntityTexture Result\Sprite,Result\Texture,0
	Result\Size = size
	ScaleSprite Result\Sprite,Size,Size
End Function

Function DestroyExplosion(explosion.tExplosion)
	FreeEntity Explosion\Sprite
	Delete Explosion
End Function

Function MoveExplosions()
	For Explosion.tExplosion = Each texplosion
		Explosion\Age = Explosion\Age + 1
		Frame# = Explosion\age /2
		If Frame <= 15 Then 
			EntityTexture explosion\Sprite,Explosion\Texture,Frame
			EntityAlpha explosion\sprite,1-(frame/16)
		Else 
			DestroyExplosion(Explosion)
		End If
	Next
End Function

Function ReadMap(X,Y)
	C = ReadPixel (X,Y,WorldBuffer)
	;Stop
	Result =Neutral
	If (C And $ff) = 0 Then Result = Black
	If (C And $ff) = $ff Then	Result = White
	Return Result
End Function

Function createBullet.tBullet(X#,Y#,Angle,Shade)
	Result.tBullet = New tBullet
	Result\X = X
	Result\Y = Y
	Result\Shade = Shade
	Result\dx=-Sin(Angle)
	Result\Dy=Cos(Angle)
	Result\Entity = CreateSphere(4,GameView)
	PositionEntity Result\Entity,X,Y,100
	If Shade=Black Then EntityColor Result\Entity,0,0,0

	Return result
End Function

Function CutHole(X,Y,Shade,Size=15)
	SetBuffer(WorldBuffer)
	If Shade=Black Then Color 0,0,0 Else Color 255,255,255
	Oval(X-Size,Y-Size,Size*2,Size*2)
	Color 255,255,255
	Oval(128-64,128-64,128,128)
	Color 0,0,0
	Oval(896-64,768+64,128,128)

	CopyRect X-Size,Y-Size,Size*2,Size*2,X-Size,Y-Size,WorldBuffer,TextureBuffer(WorldTexture)
	SetBuffer(BackBuffer())
End Function

Function Explosion(X,Y,Shade,Size=15)
	CutHole(X,Y,Shade,Size)
	CreateExplosion(X,Y,Shade,Size*2)
End Function

Function DestroyBullet(Bullet.tBullet)
	FreeEntity Bullet\Entity
	Delete Bullet
End Function

Function MoveBullets()
	For Bullet.tBullet = Each tBullet
		Bullet\X=Bullet\X+Bullet\Dx
		Bullet\Y=Bullet\Y+Bullet\dY	
		PositionEntity Bullet\Entity,Bullet\X,Bullet\Y,100
		If ReadMap(Bullet\X,Bullet\Y) <> inverseShade(Bullet\Shade) Then 
			Bullet\Dead=True
			Explosion(Bullet\X,Bullet\Y,inverseShade(Bullet\Shade))
		End If
		bullet\age=bullet\age + 1
		If bullet\age > 300 Then Bullet\dead = True
	Next
End Function

Function FreeDeadBullets()
	For Bullet.tBullet = Each tBullet
		If Bullet\Dead Then DestroyBullet(Bullet)
	Next
End Function

Function DestroyAllBullets()
	For Bullet.tBullet = Each tBullet
		 DestroyBullet(Bullet)
	Next
End Function

Function CreatePlayer.tPlayer(Shade,X#,Y#,windowLeft=0,WindowTop=0,WindowRight=1024,WindowBottom=768)
	Result.tPlayer = New tPlayer
	Result\Shade = Shade
	Result\X = X
	Result\Y = Y
	Result\InitialX = X
	Result\InitialY = Y
	Result\Angle = 0
	Result\WindowLeft=WindowLeft
	Result\WindowTop=WindowTop
	Result\WindowRight=WindowRight
	Result\WindowBottom=WindowBottom
	Result\Camera = CreateCamera
	Result\Entity = LoadMesh("Data/Ship1.3ds",GameView)
	ScaleMesh Result\Entity,0.5,0.5,0.5
	RotateMesh Result\Entity,90,0,0
	RotateMesh Result\Entity,0,180,0
;	Result\Entity = CreateCone(8,True,GameView)
	ScaleEntity Result\entity,2,4,2
	PositionEntity Result\Entity,X,Y,100
	EntityTexture Result\Entity,GlossTexture 
	
	If Shade=Black Then EntityColor Result\Entity,0,0,0
	Return result 
End Function

Function RespawnPlayer(Player.tPlayer)
	Player\X=Player\InitialX
	Player\Y=Player\InitialY
	Player\Dead = False
	CutHole(Player\X,Player\Y,inverseShade(Player\Shade),64)
End Function

Function FragPlayer(Player.tPlayer)
	Player\DeathCount = Player\DeathCount + 1
	Player\Dead = True
	CreateExplosion(Player\X,Player\Y,InverseShade(player\shade),40)
	Player\RespawnCountDown = 100
End Function

Function updatePlayers()
	For Player.tPlayer = Each tPlayer
		If player\dead Then
			Player\RespawnCountDown=Player\RespawnCountDown - 1
			If Player\RespawnCountDown <=0 Then RespawnPlayer(Player)
		Else
			Player\X=Player\X+Player\Dx
			Player\Y=Player\Y+Player\Dy
			Player\DX=Player\DX * 0.9
			Player\DY=Player\DY * 0.9
			
			PositionEntity Player\Entity,Player\X,Player\Y,100
			RotateEntity Player\Entity,0,0,Player\Angle
			Forwardx =-Sin(Player\Angle)
			ForwardY = Cos(player\Angle)
			IShade = InverseShade(Player\Shade)
			C = 		(ReadMap(Player\X,Player\Y) <> IShade)
			C=C Or	(ReadMap(Player\X+ForwardX,Player\Y+ForwardY) <> IShade)
			C=C Or	(ReadMap(Player\X+ForwardX*2,Player\Y+ForwardY*2) <> IShade )
			C=C Or	(ReadMap(Player\X+ForwardY,Player\Y-ForwardX) <> IShade)
			C=C Or	(ReadMap(Player\X-ForwardY,Player\Y+ForwardX) <> IShade)
			
			If C		  Then
				FragPlayer(Player)
				
			End If
		End If		
	Next
End Function

Function PlayerDistance#(A.tPlayer,b.TPlayer)
	Dx#=A\x-B\X
	Dy#=A\y-B\Y
	
	L2#=dx*dx+dy*dy
	If L2 = 0 Then Return 0 Else Return Sqr(L2)
	
End Function

Function PlayerFire(Player.tPlayer)
	If Not player\Dead Then
		bullet.tBullet=CreateBullet(Player\X,Player\Y,Player\Angle,Player\Shade)
	End If
End Function

Function ForcePlayer(Player.tPlayer,dx#,dy#)
	Player\dx=Player\Dx+dx
	Player\dy=Player\Dy+dy	
End Function

Function ThrustPlayer(Player.tPlayer,force#=0.2)
	If Not player\dead Then
		A=Player\Angle
		ForcePlayer(Player,-Sin(A)*Force,Cos(A)*Force)
	End If 
End Function

Function ProcessInputs(Player.tPlayer,Inputs)

	If (inLeft And Inputs) Then Player\Angle=Player\Angle + 5
	If (inRight And Inputs) Then Player\Angle=Player\Angle - 5

	If (inThrust And Inputs) Then ThrustPlayer(Player)
	
	If (inFire And Inputs) Then PlayerFire(Player)
End Function

Function SetCameraZoom(ZoomFactor#=1)
	CameraZoom GameCamera,2.0/LogicalDisplayWidth*ZoomFactor
	PositionEntity GameCamera,LogicalDisplayWidth / 2,LogicalDisplayHeight / 2,-1
	PositionEntity gamelight,4,3,-1
	LightColor Gamelight,256,256,256
	CameraProjMode GameCamera,2
End Function	
	

EntityTexture Quad,WorldTexture

FPS = 200 
period=1000/FPS 
time=MilliSecs()-period

Global Player1.tPlayer = CreatePlayer(Black,128,128)
Global Player2.tPlayer = CreatePlayer(White,896,896)



Function AddGribbly(shade,homeX,HomeY)
	Repeat 
		X = Rnd(10,1014)
		Y = Rnd(10,1014)
		dx=HomeX-X
		Dy=HomeY-Y
		d2=dx*dx+Dy*dy
		MapOK=True
		For ty = -1 To 1
			For tx=-1 To 1
				MapOk = MapOK And (ReadMap(X+tx,Y+ty) = inverseShade(Shade))
			Next
		Next
		
	Until  MapOK  And (d2 > 64*64)
	CreateGribbly(X,Y,Shade,HomeX,HomeY)
	
End Function

Function DrawScoreTable()
		SetFont ResultsFont
		ShadowText 535,344,"Dark"
		ShadowText 605,344,"Light"

		For I = 1 To CurrentRound 
			ShadowText 380,344+I*40,"Round "+I+":"
			ShadowText 550,344+I*40,DarkStats(I)
			ShadowText 620,344+I*40,LightStats(I)
		Next	
End Function

While Not KeyDown( 1 )


	If KeyHit(25) Then Paused = Not Paused
	
	If Not HasFocus() 
		Repeat 
			Delay(100) 
		Until HasFocus()
		Time = MilliSecs()-period 
	EndIf 

	Repeat
		elapsed=MilliSecs()-time
	Until elapsed

	ticks=elapsed/period
	tween#=Float(elapsed Mod period)/Float(period)
	
	If Paused Or (NetworkedGame And (RemoteNetPlayer=Null)) Or (InputsRequired > InputsReceived) Then Ticks=0
	
	If ticks > 20  Then Ticks = 1
	For k=1 To ticks
		Counter=Counter+1
		MoveGame
	Next	

	SetBuffer(BackBuffer())
	RenderWorld tween
	HandleNet()
	Select GameMode
	
	Case gmInstructions 
		DrawImage(Instructions,256,100)
		If MouseInRect(456,521,456+83,521+51) Then DrawImage(GoButton,456,521)
	Case gmGameOver
		Image= GameDrawn
		If Winner=Black Then Image = DarkWinsGame
		If Winner=White Then Image = LightWinsGame	
		DrawImage Image,320,192
		DrawScoreTable()		
		If MouseInRect(466,495,466+83,495+51) Then DrawImage (GoButton,466,495)
	Case gmRoundOver
		Image = RoundDrawn
		If BlackGribbliesHome > WhiteGribbliesHome Then Image = DarkWinsRound
		If BlackGribbliesHome <	WhiteGribbliesHome Then Image = LightWinsRound
		DrawImage Image,320,192	
		DrawScoreTable()		
		If MouseInRect(466,495,466+83,495+51) Then DrawImage (GoButton,466,495)
	Case gmAnnouncingRound 
		DrawImage RoundWindow(CurrentRound),368,289+RoundWindowY

	End Select
	
	If (GameMode = gmPlaying) Or (GameMode = gmAnnouncingRound) Then
		DrawImage (InfoPanel,0,704)
		SetFont Font
		Color 255,255,255
		;shadowText 0,20,"Zoom#="+Zoom#
		;shadowText 0,40,"Distance="+PlayerDistance(Player1,Player2)
		
		
		BlackGribblies=BlackGribbliesHome+BlackGribbliesInWild
		WhiteGribblies=WhiteGribbliesHome+WhiteGribbliesInWild
		
		shadowText 50,715,"Gribblies Home: ",True
		shadowText 50,730,BlackGribbliesHome+" / "+BlackGribblies,True
		shadowText 50,745,"Frags: "+Player2\DeathCount,True
	
		DrawImage (InfoPanel,928,0)
		shadowText 978,11,"Gribblies Home: ",True
		shadowText 978,26,WhiteGribbliesHome+" / "+WhiteGribblies,True
		shadowText 978,41,"Frags: "+Player1\DeathCount,True
	Else
		DrawImage(MousePointer,MouseX()-4,MouseY()-8)
	End If	

	; FPS
	frames=frames+1
	If MilliSecs()-render_time=>1000 Then fps=frames : frames=0 : render_time=MilliSecs()	
	shadowText 0,0,fps
	VWait : Flip False
Wend