Type tNPlayer 
	Field ID
	Field Shade 
	Field Inputs
	Field InputsPending
	Field ReadyToGo
End Type

Const NetPlayerArrived = 100
Const NetPlayerLeft = 101

Const NetKeyMessage = 1
Const NetRandSeed = 2
Const NetSetupComplete = 3
Const NetReady = 4

Global LocalNetPlayer.tNPlayer
Global RemoteNetPlayer.tNPlayer

Global HostingGame = False 
Global NetworkedGame = False 
Global InputsReceived
Global InputsSent
Global InputsRequired

Function InitNetworkGame()
	;NetGame = JoinNetGame("LightVsDark","127.0.0.1")
	NetGame = StartNetGame()
	HostingGame = (NetGame = 2)
	
	; Create a random player name 
	name$="Player" + Rand(100) 
	
	; Get a unique player id number for the player 
	; and create the player 
	playerID=CreateNetPlayer(name$) 
	
	LocalNetPlayer.tNPlayer = CreateNPlayer(PlayerID,White)
	Print "Waiting For remote player"
	While RemotenetPlayer = Null
		HandleNet()
		Delay 100
	Wend
	Print "Remote Player Found. Syncing"
	Repeat 
		HandleNet()
		Delay 100
	Until RemoteNetPlayer\ReadyToGo
	If HostingGame Then 
		LocalNetPlayer\ReadyTogo = True
		SendNetMsg NetReady,0,LocalNetPlayer\ID,0,True
	End If
	Print "Using random seed of "+ RndSeed()
	WaitKey

End Function

Function CreateNPlayer.tNPlayer(ID,Shade=Black)
	Result.tNPlayer = New tNPlayer
	Result\ID = ID
	Result\Shade = Shade
	Return Result
End Function

Function DestroyNPlayer(nPlayer.tNplayer)
	Delete nPlayer
End Function

Function FindNPlayerByID.tNPlayer(ID)
	For nPlayer.tNPlayer= Each tNplayer
		If nPlayer\ID = ID Then
			Return nPlayer
		End If
	Next	
End Function

Function DestroyNPlayerById(ID)
	DestroyNPlayer(FindNPlayerByID(ID))
End Function

Function UserMessage(NPlayer.tNPlayer,msgType,msgData$)
	Select msgType
		Case NetKeyMessage
			nPlayer\InputsPending=MsgData
			InputsReceived=InputsReceived + 1
			If InputsReceived = InputsRequired Then  nPlayer\Inputs=MsgData
		Case NetRandSeed
			SeedRnd(Int(msgData))
		Case NetSetupComplete
			LocalNetPlayer\ReadyTogo = True
			SendNetMsg NetReady,0,LocalNetPlayer\ID,NPlayer\ID,True
		Case NetReady
			NPlayer\ReadyToGo = True
	End Select 
End Function

Function InputCycle()
	For nPlayer.tNPlayer= Each tNplayer
		nPlayer\Inputs = nPlayer\InputsPending
	Next	
	InputsRequired = InputsRequired + 1
End Function

Function SendInputs(nPlayer.tNPlayer,Inputs)
	nPlayer\InputsPending = Inputs
	SendNetMsg NetKeyMessage,Inputs,nPlayer\ID,0,True
	InputsSent=InputsSent + 1
	
End Function

Function SyncRemoteNetPlayer(NetPlayer.tnplayer)
	NewRandSeed = MilliSecs() And $FFFF
	SeedRnd(NewRandSeed)
	SendNetMsg NetRandSeed,NewRandSeed,LocalNetPlayer\ID,0,True		
	SendNetMsg NetSetupComplete,0,LocalNetPlayer\ID,0,True		
End Function

Function HandleNet()
	If Not NetworkedGame Then Return 
	If RecvNetMsg() Then
		
		msgType=NetMsgType()
		From=NetMsgFrom() 		
		msgData$=NetMsgData$()
		Print msgType+":" + NetPlayerName(From)+"("+From + ") sends "+msgData$
		Select msgType
		Case NetPlayerArrived
			RemoteNetPlayer=CreateNPlayer(From)
			If HostingGame Then SyncRemoteNetPlayer(RemoteNetPlayer)
		Case NetPlayerLeft
			DestroyNPlayerByID(From)	
		Default 
			UserMessage(FindNPlayerByID(From),msgType,msgData)
		End Select
		
	End If
End Function